/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

(function() {
  var app;

  app = angular.module("datePicker", []);

app.directive("datePicker", ['$timeout', 'UtilityService', "$parse", function ($parse) {
        var uniqueId = 1;
        return {
            restrict: 'E',
            templateUrl: 'CAL/views/datePicker.html' ,
            require: "?ngModel",
            scope : false,
            link:  function (scope, element, attrs, ngModelCtrl) {
                CALVIEWCONST = {
                    DAY_COUNT : 7
                };
                
                scope.uniqueId  = uniqueId++;
                scope.days = ["WEBMOB_fhub2_common_abbr_monday", "WEBMOB_fhub2_common_abbr_tuesday", "WEBMOB_fhub2_common_abbr_wednesday", "WEBMOB_fhub2_common_abbr_thursday", "WEBMOB_fhub2_common_abbr_friday", "WEBMOB_fhub2_common_abbr_saturday", "WEBMOB_fhub2_common_abbr_sunday"];
                scope.monthNames = ["WEBMOB_fhub2_common_january","WEBMOB_fhub2_common_february","WEBMOB_fhub2_common_march","WEBMOB_fhub2_common_april","WEBMOB_fhub2_common_may","WEBMOB_fhub2_common_june","WEBMOB_fhub2_common_july","WEBMOB_fhub2_common_august","WEBMOB_fhub2_common_september","WEBMOB_fhub2_common_october","WEBMOB_fhub2_common_november","WEBMOB_fhub2_common_december"];
                scope.weeks = [];
                scope.calObj = scope.getCurrentSelectedDate();
                console.log(" scope.calObj ", scope.calObj);
                scope.selectedDate = scope.calObj;
                scope.headarLable;
                //scope.d;
                scope.nextMonthData = nextMonthData;
                scope.prevMonthData = prevMonthData;
                scope.setSelectedDate=setSelectedDate;
                
                var startDayOfMonth, endDayOfMonth;
                
                scope.years = [];
                scope.min_year = 1900;
                scope.max_year = 2100;
                scope.selected={year:null};
                
                for (var i = scope.min_year; i <= scope.max_year; i++) {
                    scope.years.push(i.toString());
                }
                
     scope.initCal = function() {
        var temp = new Date(scope.calObj.getFullYear(), scope.calObj.getMonth(), 1);
        var startDay = temp.getDay() !== 0 ? temp.getDay()-1 : CALVIEWCONST.DAY_COUNT-1;
        temp = new Date(scope.calObj.getFullYear(), scope.calObj.getMonth()+1, 0).getDay();
        var endDay =  temp !== 0  ? temp-1 : CALVIEWCONST.DAY_COUNT-1;
         
        startDayOfMonth = startDay;
        endDayOfMonth = endDay;
        
        getRowCount(startDay, endDay);
        scope.weeks = [];
        fillPrevMonthDays(startDay);
        fillNextMonthDays(endDay);
        fillCurrentMonthDays(startDay, endDay);
       
        scope.headarLable = scope.translation[scope.monthNames[scope.calObj.getMonth()]];

         scope.selected.year = scope.selectedDate.getFullYear().toString();
        
    };
    function setSelectedDate(){
        for(i=0;i<rowCount;i++)
            for(j=0;j<7;j++){
                 if(scope.selectedDate.getDate() === scope.weeks[i][j].date && scope.calObj.getMonth() === scope.selectedDate.getMonth()
                         && scope.weeks[i][j].isThisMonth && scope.calObj.getFullYear() === scope.selectedDate.getFullYear() ) {
                        scope.weeks[i][j].selected = true;
                    } else {
                        scope.weeks[i][j].selected = false;
                    }
             }
    }
    
    scope.setSelectedYear = function(year) {
        scope.selected.year = year;
        var date = new Date(new Date(scope.selectedDate).setFullYear(parseInt(scope.selected.year)));
        date.setDate(scope.selectedDate.getDate());
        scope.selectedDate=date;
        scope.calObj=scope.selectedDate;
        scope.initCal();
        setSelectedDate();
    };
     
    function fillPrevMonthDays(startDayIndex) {
        var firstWeek =  [];
        var temp = new Date();
        temp.setDate(0);
        var prevLastDate = temp.getDate();
        var offset = startDayIndex - 1;
        for(var i = 0; i <= startDayIndex-1; i++) {
          

        date = '{ "date" :' + (prevLastDate - offset + i) + ', '
                + '"selected" :' + false + ', '
                + '"today" : ' + false + ', '
                + '"isThisMonth" : ' + false + ','
                + '"class" : "dimmed-date pointer-none"'
                + '}';
            
            firstWeek[i] = JSON.parse(date);
        }
        scope.weeks[0] = firstWeek;
    }
    
    function fillNextMonthDays(endDayIndex) {
        var lastWeek = [];
        var nextDate = 1;
        for( var i = endDayIndex+1; i < CALVIEWCONST.DAY_COUNT; i++) {
            
            date = '{ "date" :' + nextDate++ +  ','
              + '"selected" :' + false + ','
              + '"today" : ' + false + ','
              + '"isThisMonth" : ' + false + ','
              + '"events" : [],'
              + '"class" : "dimmed-date pointer-none"'
              + '}';
              
              lastWeek[i] = JSON.parse(date);
        }
        scope.weeks[rowCount-1] = lastWeek;
    }
    
    function fillCurrentMonthDays(startDay, endDay) {
        var week ;
        var day = 1;
        var selected = false;
        var date = null;
        var startIdx, endIdx;
        for (var i = 0; i < rowCount; i++) {
            week = scope.weeks[i];
            if (i === 0) {
                startIdx = startDay;
                endIdx = CALVIEWCONST.DAY_COUNT;
            } else if (i === rowCount - 1) {
                startIdx = 0;
                endIdx = endDay + 1;
            } else {
                week = [];
                startIdx = 0;
                endIdx = CALVIEWCONST.DAY_COUNT;
            }

            var tempObj = scope.isCalender === 1 ? scope.createEventData.starts : scope.createEventData.ends;
            for (var j = startIdx; j < endIdx; j++) {
                    if(tempObj.getDate() === day && scope.calObj.getMonth() === tempObj.getMonth()) {
                        selected = true;
                    } else {
                        selected = false;
                    }
                
                    date = '{ "date" :' + day + ','
                    + '"selected" :' + selected + ','
                    + '"today" : ' + isToday(day, scope.calObj.getMonth(), scope.calObj.getFullYear()) + ','
                    + '"isThisMonth" : ' + true + ','
                    + '"class" : ""'
                    + '}';
                    
                  week[j] = JSON.parse(date);
                  day += 1;
            }
            scope.weeks[i] = week;
        }
    }
    
    function getRowCount(startDay, endDay) {
         var temp = new Date(scope.calObj.getFullYear(), scope.calObj.getMonth()+1, 0);
         var dayCount = temp.getDate();
         if(startDay + dayCount  <= 35 ) {
             rowCount = 5;
         } else {
             rowCount = 6;
         }
    }
    
    function isToday(date, month, year) {
        var today = new Date();
        return (today.getDate() === date && today.getMonth() === month && today.getFullYear() === year);
    }
        
    function nextMonthData() {
        var nextMonth = new Date(scope.calObj.getFullYear(), scope.calObj.getMonth()+1, 1);
        nextMonth.setHours(0);
        nextMonth.setMinutes(0);
        if(nextMonth.getFullYear() === 2101)
            return;
        
        scope.calObj = nextMonth;
        scope.initCal();
        scope.selected.year = scope.calObj.getFullYear().toString();
        setSelectedDate();
    }
    
    function prevMonthData() {
        console.log("prev Month Called before ", scope.calObj);
        var prevMonth = new Date(scope.calObj.getFullYear(), scope.calObj.getMonth()-1, scope.calObj.getDate());
        prevMonth.setHours(0);
        prevMonth.setMinutes(0);
         if(prevMonth.getFullYear() === 1899)
            return;
        
        scope.calObj = prevMonth;
        scope.initCal();
        scope.selected.year = scope.calObj.getFullYear().toString();
        setSelectedDate();
    }
    
    scope.onDateSelected = function( row, col) {
        var date = new Date(scope.calObj.getFullYear(), scope.calObj.getMonth(), (scope.weeks[row][col]).date);
        date.setHours(scope.calObj.getHours());
        date.setMinutes(scope.calObj.getMinutes());
        scope.selectedDate = date;
        setSelectedDate();       
    };
    
    scope.onDateSet = function() {
        ngModelCtrl.$modelValue = scope.selectedDate;
        scope.closePicker(ngModelCtrl.$modelValue, false);
    };
    
    scope.onCancel = function() {
        ngModelCtrl.$modelValue = new Date();
        scope.closePicker(ngModelCtrl.$modelValue, true);
    };
    scope.isYearOutofRange=function(){
    var year=scope.calObj.getFullYear();
     var month=scope.calObj.getMonth();

     if(year === scope.min_year && month === 0)
         return 1;
     if(year === scope.max_year && month === 11)
         return 2;
    };
                
    return scope.initCal();     
            }   //close link function.
        };  //close return object.
    }]);    //close directive.
}).call(this);
