/**
 * Created by jji.yeon on 2017-06-15.
 */

app.config(['$stateProvider', function ($stateProvider) {
    var localURL = '';
    var InsideImagePage = {
        name: 'InsideImagePage',
        views: {
            'home_view': {templateUrl: localURL + 'REF_ViewInside/views/InsideImage.html'}
        }
    };

    var FoodListPage = {
        name: 'FoodListPage',
        views: {
            'home_view': {templateUrl: localURL + 'REF_ViewInside/views/FoodList.html'}
        }
    };

    var FoodItemPage = {
        name: 'FoodItemPage',
        views: {
            'multi_screen': {templateUrl: localURL + 'REF_ViewInside/views/FoodItem.html'}
        }
    };

    var SettingsPage = {
        name: 'SettingsPage',
        views: {
            'multi_screen': {templateUrl: localURL + 'REF_ViewInside/views/Settings.html'}
        }
    };

    var SendToShoppingListPage = {
        name: 'SendToShoppingListPage',
        views: {
            'multi_screen': {templateUrl: localURL + 'REF_ViewInside/views/SendToShoppingList.html'}
        }
    };

    $stateProvider.state(InsideImagePage);
    $stateProvider.state(FoodListPage);
    $stateProvider.state(FoodItemPage);
    $stateProvider.state(SettingsPage);
    $stateProvider.state(SendToShoppingListPage);

}]);