app.config(['$stateProvider',
    function($stateProvider) {
        var HomePage = {
            name : 'HomePage',
            url: '',
            views: {
                '': {
                    templateUrl: 'CAL/views/home_page.html'
                },
                'calendarView@HomePage': {
                    templateUrl: 'CAL/views/calendarView.html',
                    controller : 'calendarViewController'
                },
                'hourView@HomePage': {
                    templateUrl: 'CAL/views/hourView.html',
                    controller : 'hourViewController'
                },
                'agendaView@HomePage': {
                    templateUrl: 'CAL/views/agendaView.html',
                    controller : 'agendaViewController'
                }
            }
        };

        var AddPage = {
            name : 'AddPage',
            url: '',
            templateUrl: 'CAL/views/addEventView.html'

        };
        var InviteePage = {
            name : 'InviteePage',
            url: '',
            templateUrl: 'CAL/views/InviteePage.html'

        };

        var EventDetailPage = {
            name : 'EventDetailPage',
            url: '',
            templateUrl: 'CAL/views/EventDetailPage.html'
        };

        var AlertPage = {
            name : 'AlertPage',
            url: '',
            templateUrl: 'CAL/views/alertPage.html'
        };

        var RepeatPage = {
            name : 'RepeatPage',
            url: '',
            templateUrl: 'CAL/views/repeatPage.html'
        };
        $stateProvider.state(HomePage);
        $stateProvider.state(EventDetailPage);
        $stateProvider.state(InviteePage);
        $stateProvider.state(AddPage);
        $stateProvider.state(AlertPage);
        $stateProvider.state(RepeatPage);
    }
]);